diff -Naur -X diff_ignore rsync-3.0.6_base/generator.c rsync/generator.c
--- rsync-3.0.6_base/generator.c	2009-06-18 17:30:50.000000000 -0400
+++ rsync/generator.c	2019-01-14 17:30:40.000000000 -0500
@@ -2122,13 +2466,33 @@
 		 || (!need_retouch_dir_times && file->mode & S_IWUSR))
 			continue;
 		fname = f_name(file, NULL);
-		if (!(file->mode & S_IWUSR))
-			do_chmod(fname, file->mode, 0);
-		if (need_retouch_dir_times) {
-			STRUCT_STAT st;
-			if (link_stat(fname, &st, 0) == 0
-			 && cmp_time(st.st_mtime, file->modtime) != 0)
-				set_modtime(fname, file->modtime, file->mode, 0);
+
+#ifdef PARSEABLE_OUTPUT
+		if (!inc_recurse) {
+			struct timeval now;
+			gettimeofday(&now, NULL);
+	
+			unsigned long time_diff = msdiff(&last_update, &now);
+			if (time_diff > 200 && end > 0) { // Print update information every fifth of a second, avoid divide by zero crash!
+				last_update = now;
+				rprintf(FINFO, "S;;;TU;;;PROG;;;%d;;;CF;;;%s\n", (i * 100) / end, fname);
+			}
+		}
+#endif
+
+		STRUCT_STAT st;
+		if (link_stat(fname, &st, 0) == 0) {
+			/* Don't change the mode on the root folder of an HFS+ volume */
+			if (file->mode != st.st_mode && st.st_ino != 2)
+				do_chmod(fname, file->mode, 0);
+			if (need_retouch_dir_times) {
+				 if ((receiver_uid == 0 || receiver_uid == st.st_uid)
+				 && cmp_time(st.st_mtime, file->modtime) != 0)
+					// BOMBICH: I set the fourth argument to F_FFLAGS(file) to force
+					// a stat of the folder, otherwise set_modtime might not call
+					// make_mutable properly
+					set_modtime(fname, file->modtime, file->mode, F_FFLAGS(file));
+			}
 		}
 #ifdef SUPPORT_FORCE_CHANGE
 		if (force_change && F_FFLAGS(file) & force_change)
@@ -2157,6 +2521,8 @@
 			flist = flist_for_ndx(ndx, "check_for_finished_files.1");
 			file = flist->files[ndx - flist->ndx_start];
 			assert(file->flags & FLAG_HLINKED);
+			if (verbose > 1)
+				fprintf(stderr, "check_for_finished_files: Calling finish_hard_link() for %s\n", f_name(file, NULL));
 			finish_hard_link(file, f_name(file, fbuf), ndx, NULL, itemizing, code, -1);
 			flist->in_progress--;
 			continue;
@@ -2301,6 +2667,7 @@
 			else
 				f_name(fp, fbuf);
 			ndx = cur_flist->ndx_start - 1;
+
 			recv_generator(fbuf, fp, ndx, itemizing, code, f_out);
 			if (delete_during && dry_run < 2 && !list_only
 			 && !(fp->flags & FLAG_MISSING_DIR)) {
@@ -2418,3 +2785,131 @@
 	if (verbose > 2)
 		rprintf(FINFO, "generate_files finished\n");
 }
+
+int copy_sparse_file(const char *src, const char *dst, mode_t mode, off_t logicalSize, off_t physicalSize, int sparse_files)
+{
+	int fdin, fdout, result = 0;
+	off_t dataSkipped = 0, dataWritten = 0;
+	char *buf;
+	struct timeval now;
+
+	// We attempt to open the source file even if the physical size is 0. This allows us to capture an
+	// EACCES error from OneDrive placeholder files and then avoid copying them
+	fdin = open(src, O_RDONLY);
+	if (fdin < 0) {
+		if (errno == EACCES && physicalSize == 0) {
+			fprintf(stderr, "DEBUG: Dropping placeholder: %s\n", src);
+		} else {
+			fprintf(stderr, "DEBUG: sparse_open '%s' failed: %s\n", src, strerror(errno));
+		}
+		return 1;
+	}
+	
+	fdout = open(dst, O_RDWR | O_CREAT | O_TRUNC, mode);
+	if (fdout < 0) {
+		fprintf(stderr, "DEBUG: sparse_open '%s' failed: %s\n", dst, strerror(errno));
+		close(fdin);
+		return 1;
+	}
+	
+	if (physicalSize == 0) {
+		if (ftruncate(fdout, sparse_files ? logicalSize : 0) != 0) {
+			fprintf(stderr, "DEBUG: ftruncate(%lld) failed on %s: %s\n", logicalSize, dst, strerror(errno));
+			result = 1;
+		}
+		close(fdin);
+		close(fdout);
+		return result;
+	}
+
+	fprintf(stderr, "DEBUG: Physical size: %lld, logical size: %lld, difference: %lld [%s]\n", physicalSize, logicalSize, logicalSize - physicalSize, src);
+	buf = (char *)malloc(write_size);
+	if (!buf) {
+		fprintf(stderr, "DEBUG: malloc failed: %s\n", strerror(errno));
+		close(fdin);
+		close(fdout);
+		return 1;
+	}
+	
+	off_t in_offset = 0;
+	while (in_offset < logicalSize) {
+		off_t data_offset, hole_offset, chunkSize, availableData;
+		data_offset = lseek(fdin, in_offset, SEEK_DATA);
+		if (data_offset < 0) {
+			if (errno == ENXIO) {
+				dataSkipped += (logicalSize - in_offset);
+				// No more data chunks past the current offset. Truncate the destination file.
+				if (ftruncate(fdout, logicalSize) != 0) {
+					fprintf(stderr, "DEBUG: ftruncate failed on destination file: %s\n", strerror(errno));
+					result = 1;
+				}
+			} else {
+				fprintf(stderr, "DEBUG: lseek failed on source file: %s\n", strerror(errno));
+				result = 1;
+			}
+			break;
+		}
+		
+		if (data_offset > in_offset) {
+			if (verbose)
+				fprintf(stderr, "DEBUG: Skipping an empty chunk of %lld bytes\n", data_offset - in_offset);
+			dataSkipped += (data_offset - in_offset);
+			in_offset = data_offset;
+			if (lseek(fdout, data_offset, SEEK_SET) != data_offset) {
+				fprintf(stderr, "DEBUG: lseek failed on destination file: %s\n", strerror(errno));
+				result = 1;
+				break;
+			}
+		}
+		
+		// Find the offset of the next hole, then reset the offset
+		hole_offset = lseek(fdin, data_offset, SEEK_HOLE);
+		lseek(fdin, data_offset, SEEK_SET);
+		availableData = hole_offset - data_offset;
+		if (verbose)
+			fprintf(stderr, "DEBUG: Reading a data chunk of %lld bytes\n", availableData);
+		
+		// Read data starting at data_offset up to hole_offset in, at most, ioWriteSize chunks
+		while (availableData > 0) {
+			gettimeofday(&now, NULL);
+			unsigned long time_diff = msdiff(&last_update, &now);
+			if (time_diff > 100) {
+				last_update = now;
+				rprintf(FINFO, "S;;;CP;;;SPARSE;;;%lld;;;CF;;;%s\n", sparseDataCopied, src);
+			}
+			
+			chunkSize = (availableData < write_size) ? availableData : write_size;
+			ssize_t readData, writtenData;
+			bzero(buf, write_size);
+			readData = read(fdin, buf, chunkSize);
+			if (readData < 0) {
+				fprintf(stderr, "DEBUG: read failed: %s\n", strerror(errno));
+				result = 1;
+				hole_offset = logicalSize;
+				break;
+			}
+			writtenData = write(fdout, buf, chunkSize);
+			if (writtenData != readData) {
+				fprintf(stderr, "DEBUG: write failed: %s\n", strerror(errno));
+				result = 1;
+				hole_offset = logicalSize;
+				break;
+			}
+			
+			sparseDataCopied += writtenData;
+			dataWritten += writtenData;
+			availableData -= readData;
+		}
+		
+		in_offset = hole_offset;
+	}
+	
+	sparseFilesCopied++;
+	fprintf(stderr, "S;;;CP;;;SPARSE;;;%lld;;;SPCP;;;%d;;;CF;;;%s\n", sparseDataCopied, sparseFilesCopied, src);
+	
+	close(fdin);
+	close(fdout);
+	free(buf);
+	return result;
+}
+
diff -Naur -X diff_ignore rsync-3.0.6_base/hashtable.c rsync/hashtable.c
--- rsync-3.0.6_base/hashtable.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/hashtable.c	2016-12-28 22:47:47.000000000 -0500
@@ -87,7 +87,7 @@
 		uchar buf[4], *keyp = buf;
 		int i;
 
-		SIVAL(buf, 0, key);
+		SIVALu(buf, 0, key);
 		for (ndx = 0, i = 0; i < 4; i++) {
 			ndx += keyp[i];
 			ndx += (ndx << 10);
diff -Naur -X diff_ignore rsync-3.0.6_base/hlink.c rsync/hlink.c
--- rsync-3.0.6_base/hlink.c	2009-06-18 17:30:46.000000000 -0400
+++ rsync/hlink.c	2018-09-07 12:18:42.000000000 -0400
@@ -31,6 +31,7 @@
 extern int link_dest;
 extern int preserve_acls;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
 extern int make_backups;
 extern int protocol_version;
 extern int remove_source_files;
@@ -134,6 +135,7 @@
 				else {
 					/* We skipped all prior files in this
 					 * group, so mark this as a "first". */
+					fprintf(stderr, "DEBUG: Previous hard links were skipped, marking this file as a first: %s\n", file->basename);
 					file->flags |= FLAG_HLINK_FIRST;
 					prev = -1;
 				}
@@ -209,6 +211,8 @@
 			   const char *oldname, STRUCT_STAT *old_stp,
 			   const char *realname, int itemizing, enum logcode code)
 {
+	if (verbose > 1)
+		fprintf(stderr, "maybe_hard_link: %s => %s, statret: %d, size of original: %lld\n", full_fname(fname), oldname, statret, old_stp->st_size);
 	if (statret == 0) {
 		if (sxp->st.st_dev == old_stp->st_dev
 		 && sxp->st.st_ino == old_stp->st_ino) {
@@ -223,22 +227,39 @@
 			return 0;
 		}
 		if (make_backups > 0) {
+			if (verbose > 1)
+				fprintf(stderr, "maybe_hard_link: calling make_backup() on %s\n", full_fname(fname));
 			if (!make_backup(fname))
 				return -1;
 		} else if (robust_unlink(fname)) {
-			rsyserr(FERROR_XFER, errno, "unlink %s failed",
+			rsyserr(FERROR_XFER, errno, "maybe_hard_link: unlink %s failed",
 				full_fname(fname));
 			return -1;
 		}
 	}
 
+	if (verbose > 1)
+		fprintf(stderr, "maybe_hard_link: %s, oldname: %s\n", fname, oldname);
+
 	if (hard_link_one(file, fname, oldname, 0)) {
+		if (verbose > 1)
+			fprintf(stderr, "maybe_hard_link: hard_link_one > 0\n");
+		// If the hard link was successful, restat the destination file
+		statret = link_stat(fname, &sxp->st, 0);
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (sxp->st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				sxp->st.st_size = 0;
+			} else
+				sxp->st.st_flags &= ~UF_COMPRESSED;
+		}
+#endif
 		if (itemizing) {
 			itemize(fname, file, ndx, statret, sxp,
 				ITEM_LOCAL_CHANGE | ITEM_XNAME_FOLLOWS, 0,
 				realname);
 		}
-		if (code != FNONE && verbose)
+		if (code != FNONE && verbose > 1)
 			rprintf(code, "%s => %s\n", fname, realname);
 		return 0;
 	}
@@ -270,6 +291,10 @@
 
 	if (inc_recurse
 	 && (node = hashtable_find(prior_hlinks, gnum, 0)) != NULL) {
+		if (node->data == NULL) {
+			fprintf(stderr, "DEBUG: check_prior: Assertion failure coming, hard link %s\n", full_fname(file->basename));
+			fflush(stderr);
+		}
 		assert(node->data != NULL);
 		if (CVAL(node->data, 0) != 0) {
 			*prev_ndx_p = -1;
@@ -300,6 +325,9 @@
 
 	prev_name = realname = check_prior(file, gnum, &prev_ndx, &flist);
 
+	if (verbose > 1)
+		fprintf(stderr, "hlink(%s): hard_link_check (%s)\n", who_am_i(), full_fname(fname));
+
 	if (!prev_name) {
 		struct file_struct *prev_file;
 
@@ -309,12 +337,19 @@
 			return 0;
 		}
 
+		if (verbose > 1)
+			fprintf(stderr, "hlink(%s): hard_link_check prev file not skipped (%s)\n", who_am_i(), full_fname(fname));
+
 		prev_file = flist->files[prev_ndx - flist->ndx_start];
 
 		/* Is the previous link not complete yet? */
 		if (!(prev_file->flags & FLAG_HLINK_DONE)) {
 			/* Is the previous link being transferred? */
+			if (verbose > 1)
+				fprintf(stderr, "hlink(%s): hard_link_check prev link not done (%s)\n", who_am_i(), full_fname(fname));
 			if (prev_file->flags & FLAG_FILE_SENT) {
+				if (verbose > 1)
+					fprintf(stderr, "hlink(%s): hard_link_check prev file sent (%s)\n", who_am_i(), full_fname(fname));
 				/* Add ourselves to the list of files that will
 				 * be updated when the transfer completes, and
 				 * mark ourself as waiting for the transfer. */
@@ -324,9 +359,14 @@
 				cur_flist->in_progress++;
 				return 1;
 			}
+			if (verbose > 1)
+				fprintf(stderr, "hlink(%s): hard_link_check prev file not sent (%s)\n", who_am_i(), full_fname(fname));
 			return 0;
 		}
 
+		if (verbose > 1)
+			fprintf(stderr, "hlink(%s): hard_link_check prev link is complete (%s)\n", who_am_i(), full_fname(fname));
+
 		/* There is a finished file to link with! */
 		if (!(prev_file->flags & FLAG_HLINK_FIRST)) {
 			/* The previous previous is FIRST when prev is not. */
@@ -355,12 +395,24 @@
 		}
 	}
 
+	if (verbose > 1)
+		fprintf(stderr, "hlink(%s): hard_link_check stating prev_name (%s) for (%s)\n", who_am_i(), prev_name, fname);
+
 	if (link_stat(prev_name, &prev_st, 0) < 0) {
-		rsyserr(FERROR_XFER, errno, "stat %s failed",
+		rsyserr(FERROR_XFER, errno, "hard_link_check: stat %s failed",
 			full_fname(prev_name));
 		return -1;
 	}
 
+#ifdef SUPPORT_HFS_COMPRESSION
+	if (prev_st.st_flags & UF_COMPRESSED) {
+		if (preserve_hfs_compression > 0) {
+			prev_st.st_size = 0;
+		} else
+			prev_st.st_flags &= ~UF_COMPRESSED;
+	}
+#endif
+	
 	if (statret < 0 && basis_dir[0] != NULL) {
 		/* If we match an alt-dest item, we don't output this as a change. */
 		char cmpbuf[MAXPATHLEN];
@@ -377,6 +429,15 @@
 			pathjoin(cmpbuf, MAXPATHLEN, basis_dir[j], fname);
 			if (link_stat(cmpbuf, &alt_sx.st, 0) < 0)
 				continue;
+#ifdef SUPPORT_HFS_COMPRESSION
+			if (alt_sx.st.st_flags & UF_COMPRESSED) {
+				if (preserve_hfs_compression > 0) {
+					alt_sx.st.st_size = 0;
+				} else
+					alt_sx.st.st_flags &= ~UF_COMPRESSED;
+			}
+#endif
+	
 			if (link_dest) {
 				if (prev_st.st_dev != alt_sx.st.st_dev
 				 || prev_st.st_ino != alt_sx.st.st_ino)
@@ -391,9 +452,17 @@
 				}
 				break;
 			}
+			
+			if (verbose > 1)
+				fprintf(stderr, "hlink(%s): hard_link_check calling unchanged_file(%s)\n", who_am_i(), full_fname(fname));
+
 			if (!unchanged_file(cmpbuf, file, &alt_sx.st))
 				continue;
 			statret = 1;
+
+			if (verbose > 1)
+				fprintf(stderr, "hlink(%s): hard_link_check calling unchanged_attrs(%s)\n", who_am_i(), full_fname(fname));
+
 			if (unchanged_attrs(cmpbuf, file, &alt_sx))
 				break;
 		} while (basis_dir[++j] != NULL);
@@ -455,7 +524,7 @@
 			code = FINFO;
 		} else
 			code = FERROR_XFER;
-		rsyserr(code, errno, "link %s => %s failed",
+		rsyserr(code, errno, "hard_link_one: link %s => %s failed",
 			full_fname(fname), oldname);
 		return 0;
 	}
@@ -476,9 +545,17 @@
 	struct file_list *flist;
 	int prev_statret, ndx, prev_ndx = F_HL_PREV(file);
 
+	if (verbose > 1) {
+		struct stat vst;
+		if (stat(fname, &vst) < 0)
+			fprintf(stderr, "finish_hard_link: Failed to stat %s!\n", full_fname(fname));
+		else 
+			fprintf(stderr, "finish_hard_link: File size at %s is %.0f\n", full_fname(fname), (double)vst.st_size);
+	}
+
 	if (stp == NULL && prev_ndx >= 0) {
 		if (link_stat(fname, &st, 0) < 0) {
-			rsyserr(FERROR_XFER, errno, "stat %s failed",
+			rsyserr(FERROR_XFER, errno, "finish_hard_link: stat %s failed",
 				full_fname(fname));
 			return;
 		}
@@ -511,6 +588,10 @@
 		prev_ndx = F_HL_PREV(file);
 		F_HL_PREV(file) = fin_ndx;
 		prev_statret = link_stat(f_name(file, prev_name), &prev_sx.st, 0);
+		if (verbose > 1) {
+			fprintf(stderr, "finish_hard_link: prev_statret: %d, prev_sx.st.st_size: %lu (%s)\n", prev_statret, (unsigned long)prev_sx.st.st_size, full_fname(prev_name));
+			fprintf(stderr, "finish_hard_link: stp.st_size: %lu (%s)\n", (unsigned long)stp->st_size, full_fname(our_name));
+		}
 		val = maybe_hard_link(file, ndx, prev_name, prev_statret, &prev_sx,
 				      our_name, stp, fname, itemizing, code);
 		flist->in_progress--;
@@ -531,11 +612,19 @@
 	if (inc_recurse) {
 		int gnum = F_HL_GNUM(file);
 		struct ht_int32_node *node = hashtable_find(prior_hlinks, gnum, 0);
+		if (node == NULL || node->data == NULL) {
+			fprintf(stderr, "DEBUG: finish_hard_link: Assertion failure coming, hard link %s => %s\n", full_fname(prev_name), our_name);
+			fflush(stderr);
+//		} else {
+//			fprintf(stderr, "DEBUG: finish_hard_link: hard link %s => %s; node->data: %s\n", full_fname(prev_name), our_name, node->data);
+		}
+		
 		assert(node != NULL && node->data != NULL);
 		assert(CVAL(node->data, 0) == 0);
 		free(node->data);
 		if (!(node->data = strdup(our_name)))
 			out_of_memory("finish_hard_link");
+//		fprintf(stderr, "DEBUG: finish_hard_link: hard link %s => %s; node->data: %s\n", full_fname(prev_name), our_name, node->data);
 	}
 }
 
diff -Naur -X diff_ignore rsync-3.0.6_base/io.c rsync/io.c
--- rsync-3.0.6_base/io.c	2019-01-14 13:23:49.000000000 -0500
+++ rsync/io.c	2016-06-21 10:52:35.000000000 -0400
@@ -59,6 +59,7 @@
 extern int filesfrom_convert;
 extern iconv_t ic_send, ic_recv;
 #endif
+extern int io_buf_size;
 
 const char phase_unknown[] = "unknown";
 int ignore_timeout = 0;
@@ -194,8 +195,8 @@
 
 	if (t - last_io_in >= io_timeout) {
 		if (!am_server && !am_daemon) {
-			rprintf(FERROR, "io timeout after %d seconds -- exiting\n",
-				(int)(t-last_io_in));
+			rprintf(FERROR, "[%s] io timeout after %d seconds -- exiting\n",
+				who_am_i(), (int)(t-last_io_in));
 		}
 		exit_cleanup(RERR_TIMEOUT);
 	}
@@ -373,6 +374,7 @@
 				who_am_i(), IVAL(buf,0));
 		}
 		flist = recv_file_list(fd);
+			//fprintf(stderr, "DEBUG: [%s]read_msg_fd received %d items\n", who_am_i(), flist->used);
 		flist->parent_ndx = IVAL(buf,0);
 #ifdef SUPPORT_HARD_LINKS
 		if (preserve_hard_links)
@@ -391,10 +393,12 @@
 		io_error |= IVAL(buf, 0);
 		break;
 	case MSG_DELETED:
+	case MSG_FILTERED:
+	case MSG_ARCHIVED:
 		if (len >= (int)sizeof buf || !am_generator)
 			goto invalid_msg;
 		readfd(fd, buf, len);
-		send_msg(MSG_DELETED, buf, len, 1);
+		send_msg(tag, buf, len, 1);
 		break;
 	case MSG_SUCCESS:
 		if (len != 4 || !am_generator)
@@ -596,6 +600,8 @@
 	rprintf(FERROR, RSYNC_NAME ": connection unexpectedly closed "
 		"(%.0f bytes received so far) [%s]\n",
 		(double)stats.total_read, who_am_i());
+	fprintf(stderr, "rsync: connection unexpectedly closed (%.0f bytes received so far) [%s]\n", (double)stats.total_read, who_am_i());
+	fflush(stderr);
 
 	exit_cleanup(RERR_STREAMIO);
 }
@@ -897,7 +903,7 @@
 		assert(f_out == iobuf_f_out);
 		return 0;
 	}
-	if (!(iobuf_out = new_array(char, IO_BUFFER_SIZE)))
+	if (!(iobuf_out = new_array(char, io_buf_size)))
 		out_of_memory("io_start_buffering_out");
 	iobuf_out_cnt = 0;
 	iobuf_f_out = f_out;
@@ -910,7 +916,7 @@
 		assert(f_in == iobuf_f_in);
 		return 0;
 	}
-	iobuf_in_siz = 2 * IO_BUFFER_SIZE;
+	iobuf_in_siz = 2 * io_buf_size;
 	if (!(iobuf_in = new_array(char, iobuf_in_siz)))
 		out_of_memory("io_start_buffering_in");
 	iobuf_f_in = f_in;
@@ -1050,6 +1056,8 @@
 			io_error |= IVAL(line, 0);
 			break;
 		case MSG_DELETED:
+		case MSG_FILTERED:
+		case MSG_ARCHIVED:
 			if (msg_bytes >= sizeof line)
 				goto overflow;
 #ifdef ICONV_OPTION
@@ -1084,11 +1092,17 @@
 #endif
 				read_loop(fd, line, msg_bytes);
 			/* A directory name was sent with the trailing null */
-			if (msg_bytes > 0 && !line[msg_bytes-1])
-				log_delete(line, S_IFDIR);
-			else {
+			if (msg_bytes > 0 && !line[msg_bytes-1]) {
+				if (tag == MSG_DELETED)
+					log_delete(line, S_IFDIR);
+				else
+					log_non_transfer(line, S_IFDIR, tag == MSG_ARCHIVED ? ITEM_ARCHIVED : am_generator ? ITEM_EXCLUDED : ITEM_PROTECTED);
+			} else {
 				line[msg_bytes] = '\0';
-				log_delete(line, S_IFREG);
+				if (tag == MSG_DELETED)
+					log_delete(line, S_IFREG);
+				else
+					log_non_transfer(line, S_IFREG, tag == MSG_ARCHIVED ? ITEM_ARCHIVED : am_generator ? ITEM_EXCLUDED : ITEM_PROTECTED);
 			}
 			break;
 		case MSG_SUCCESS:
@@ -1304,8 +1318,8 @@
 		len = (len & ~0x80) * 0x100 + read_byte(f);
 
 	if (len >= bufsize) {
-		rprintf(FERROR, "over-long vstring received (%d > %d)\n",
-			len, bufsize - 1);
+		rprintf(FERROR, "[%s] over-long vstring received (%d > %d)\n",
+			who_am_i(), len, bufsize - 1);
 		return -1;
 	}
 
@@ -1477,6 +1491,7 @@
 		if (count <= 0) {
 			if (count < 0 && errno == EBADF)
 				exit_cleanup(RERR_SOCKETIO);
+			//fprintf(stderr, "DEBUG: writefd_unbuffered: checking for timeout. Count: %d, errno: %d\n", count, errno);
 			check_timeout();
 			continue;
 		}
@@ -1580,7 +1595,7 @@
 	}
 
 	while (len) {
-		int n = MIN((int)len, IO_BUFFER_SIZE - iobuf_out_cnt);
+		int n = MIN((int)len, io_buf_size - iobuf_out_cnt);
 		if (n > 0) {
 			memcpy(iobuf_out+iobuf_out_cnt, buf, n);
 			buf += n;
@@ -1588,7 +1603,7 @@
 			iobuf_out_cnt += n;
 		}
 
-		if (iobuf_out_cnt == IO_BUFFER_SIZE)
+		if (iobuf_out_cnt == io_buf_size)
 			io_flush(NORMAL_FLUSH);
 	}
 }
diff -Naur -X diff_ignore rsync-3.0.6_base/lib/md5.c rsync/lib/md5.c
--- rsync-3.0.6_base/lib/md5.c	2007-07-10 09:55:49.000000000 -0400
+++ rsync/lib/md5.c	2018-01-18 11:22:00.000000000 -0500
@@ -27,6 +27,7 @@
 	ctx->D = 0x10325476;
 
 	ctx->totalN = ctx->totalN2 = 0;
+	memset(ctx->buffer, 0, CSUM_CHUNK);
 }
 
 static void md5_process(md_context *ctx, const uchar data[CSUM_CHUNK])
@@ -38,22 +39,22 @@
 	C = ctx->C;
 	D = ctx->D;
 
-	X[0] = IVAL(data, 0);
-	X[1] = IVAL(data, 4);
-	X[2] = IVAL(data, 8);
-	X[3] = IVAL(data, 12);
-	X[4] = IVAL(data, 16);
-	X[5] = IVAL(data, 20);
-	X[6] = IVAL(data, 24);
-	X[7] = IVAL(data, 28);
-	X[8] = IVAL(data, 32);
-	X[9] = IVAL(data, 36);
-	X[10] = IVAL(data, 40);
-	X[11] = IVAL(data, 44);
-	X[12] = IVAL(data, 48);
-	X[13] = IVAL(data, 52);
-	X[14] = IVAL(data, 56);
-	X[15] = IVAL(data, 60);
+	X[0] = IVALu(data, 0);
+	X[1] = IVALu(data, 4);
+	X[2] = IVALu(data, 8);
+	X[3] = IVALu(data, 12);
+	X[4] = IVALu(data, 16);
+	X[5] = IVALu(data, 20);
+	X[6] = IVALu(data, 24);
+	X[7] = IVALu(data, 28);
+	X[8] = IVALu(data, 32);
+	X[9] = IVALu(data, 36);
+	X[10] = IVALu(data, 40);
+	X[11] = IVALu(data, 44);
+	X[12] = IVALu(data, 48);
+	X[13] = IVALu(data, 52);
+	X[14] = IVALu(data, 56);
+	X[15] = IVALu(data, 60);
 
 #define S(x,n) ((x << n) | ((x & 0xFFFFFFFF) >> (32 - n)))
 
@@ -192,8 +193,8 @@
 	     | (ctx->totalN2 <<  3);
 	low  = (ctx->totalN <<  3);
 
-	SIVAL(msglen, 0, low);
-	SIVAL(msglen, 4, high);
+	SIVALu(msglen, 0, low);
+	SIVALu(msglen, 4, high);
 
 	last = ctx->totalN & 0x3F;
 	padn = last < 56 ? 56 - last : 120 - last;
@@ -201,10 +202,10 @@
 	md5_update(ctx, md5_padding, padn);
 	md5_update(ctx, msglen, 8);
 
-	SIVAL(digest, 0, ctx->A);
-	SIVAL(digest, 4, ctx->B);
-	SIVAL(digest, 8, ctx->C);
-	SIVAL(digest, 12, ctx->D);
+	SIVALu(digest, 0, ctx->A);
+	SIVALu(digest, 4, ctx->B);
+	SIVALu(digest, 8, ctx->C);
+	SIVALu(digest, 12, ctx->D);
 }
 
 void get_md5(uchar *out, const uchar *input, int n)
diff -Naur -X diff_ignore rsync-3.0.6_base/lib/mdigest.h rsync/lib/mdigest.h
--- rsync-3.0.6_base/lib/mdigest.h	2007-03-18 02:00:53.000000000 -0400
+++ rsync/lib/mdigest.h	2018-09-17 15:35:28.000000000 -0400
@@ -4,7 +4,7 @@
 #define MD5_DIGEST_LEN 16
 #define MAX_DIGEST_LEN MD5_DIGEST_LEN
 
-#define CSUM_CHUNK 64
+#define CSUM_CHUNK 64//4096 is ideal, but causes a math issue somewhere with a remote Mac source
 
 typedef struct {
 	uint32 A, B, C, D;
diff -Naur -X diff_ignore rsync-3.0.6_base/lib/sysacls.c rsync/lib/sysacls.c
--- rsync-3.0.6_base/lib/sysacls.c	2008-07-23 00:35:21.000000000 -0400
+++ rsync/lib/sysacls.c	2017-04-10 14:14:23.000000000 -0400
@@ -2585,10 +2585,8 @@
 }
 
 #elif defined(HAVE_OSX_ACLS) /*----------------------------------------------*/
-
-#define OSX_BROKEN_GETENTRY /* returns 0 instead of 1 */
-
-#include <membership.h>
+#pragma mark Mac OS X ACL Support
+#define OSX_BROKEN_GETENTRY /* returns 0 instead of 1 */ // Why is this called "broken"? Returning 0 on success and -1 on error is standard
 
 int sys_acl_get_entry(SMB_ACL_T the_acl, int entry_id, SMB_ACL_ENTRY_T *entry_p)
 {
@@ -2596,7 +2594,8 @@
 #ifdef OSX_BROKEN_GETENTRY
 	if (ret == 0)
 		ret = 1;
-	else if (ret == -1 && errno == 22)
+	//else if (ret == -1 && errno == 22) // In what case is it desirable to return -1?
+	else
 		ret = 0;
 #endif
 	return ret;
@@ -2619,31 +2618,49 @@
 }
 #endif
 
-int sys_acl_get_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T *tag_type_p, uint32 *bits_p, id_t *u_g_id_p)
+int sys_acl_get_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T *tag_type_p, uint32 *bits_p, unsigned char **uup)
 {
-	uuid_t *uup;
 	acl_tag_t tag;
 	acl_flagset_t flagset;
 	acl_permset_t permset;
 	uint32 bits, fb, bb, pb;
-	int id_type = -1;
-	int rc;
-
-	if (acl_get_tag_type(entry, &tag) != 0
-	 || acl_get_flagset_np(entry, &flagset) != 0
-	 || acl_get_permset(entry, &permset) != 0
-	 || (uup = acl_get_qualifier(entry)) == NULL)
-		return -1;
-
-	rc = mbr_uuid_to_id(*uup, u_g_id_p, &id_type);
-	acl_free(uup);
-	if (rc != 0)
-		return rc;
+	int ret = 0;
 
-	if (id_type == ID_TYPE_UID)
-		*tag_type_p = SMB_ACL_USER;
-	else
-		*tag_type_p = SMB_ACL_GROUP;
+	ret = acl_get_tag_type(entry, &tag);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_get_info: acl_get_tag_type failed: %d\n", errno);
+		return -1;
+	}
+	ret = acl_get_flagset_np(entry, &flagset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_get_info: acl_get_flagset_np failed: %d\n", errno);
+		return -1;
+	}
+	ret = acl_get_permset(entry, &permset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_get_info: acl_get_permset failed: %d\n", errno);
+		return -1;
+	}
+	
+	if (tag == ACL_UNDEFINED_TAG) {
+		// Apparently it is legal to have an ACE with a NULL qualifier and an invalid tag
+		// Even if it is allowed, though, it does not seem right to propagate the ACE
+		*uup = NULL;
+		//fprintf(stderr, "DEBUG: sys_acl_get_info[%s]: acl_get_qualifier failed with EINVAL. Tag type: %d. This ACE will be dropped by the receiver.\n", who_am_i(), tag);
+	} else {
+		ret = ((*uup = acl_get_qualifier(entry)) == NULL);
+		if (ret != 0) {
+			fprintf(stderr, "DEBUG: sys_acl_get_info: acl_get_qualifier failed: %d\n", errno);
+			return -1;
+		}
+	}
+
+	// OS X uses tag_type differently from other platforms. As far as rsync is concerned,
+	// tag_type is ignored for OS X because ACEs use UUID values, rather than the
+	// more ambiguous uid/gid. OS X never needs to differentiate a uid from a gid.
+	// We use "SMB_ACL_GROUP" here, but the value is ignored. We will stuff the
+	// OS X-proprietary "allow" and "deny" tag types into the access bits below
+	*tag_type_p = SMB_ACL_GROUP;
 
 	bits = tag == ACL_EXTENDED_ALLOW ? 1 : 0;
 
@@ -2672,20 +2689,33 @@
 	return acl_create_entry(pacl, pentry);
 }
 
-int sys_acl_set_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T tag_type, uint32 bits, id_t u_g_id)
+int sys_acl_set_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T tag_type, uint32 bits, unsigned char *uu)
 {
 	acl_flagset_t flagset;
 	acl_permset_t permset;
 	uint32 fb, bb, pb;
-	int is_user = tag_type == SMB_ACL_USER;
-	uuid_t uu;
-	int rc;
+	int ret;
+
+	// Drop entries with null uuids
+	if (uu[0] == '\0') {
+		//fprintf(stderr, "DEBUG: sys_acl_set_info[%s]: Dropping ACE with NULL UUID\n", who_am_i());
+		return 0;
+	}
 
+	// tag_type (as passed in to this function) is ignored on OS X, see sys_acl_get_info()
+	// We instead infer the OS X-specific tag type from the access bits
 	tag_type = bits & 1 ? ACL_EXTENDED_ALLOW : ACL_EXTENDED_DENY;
 
-	if (acl_get_flagset_np(entry, &flagset) != 0
-	 || acl_get_permset(entry, &permset) != 0)
+	ret = acl_get_flagset_np(entry, &flagset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_get_flagset_np failed: %d\n", errno);
 		return -1;
+	}
+	ret = acl_get_permset(entry, &permset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_get_permset failed: %d\n", errno);
+		return -1;
+	}
 
 	acl_clear_flags_np(flagset);
 	acl_clear_perms(permset);
@@ -2699,19 +2729,30 @@
 		if (bits & bb)
 			acl_add_perm(permset, pb);
 	}
+	
+	ret = acl_set_tag_type(entry, tag_type);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_set_tag_type failed: %d\n", errno);
+		return -1;
+	}
 
-	if (is_user)
-		rc = mbr_uid_to_uuid(u_g_id, uu);
-	else
-		rc = mbr_gid_to_uuid(u_g_id, uu);
-	if (rc != 0)
-		return rc;
-
-	if (acl_set_tag_type(entry, tag_type) != 0
-	 || acl_set_qualifier(entry, &uu) != 0
-	 || acl_set_permset(entry, permset) != 0
-	 || acl_set_flagset_np(entry, flagset) != 0)
+	ret = acl_set_qualifier(entry, uu);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_set_qualifier failed: %d\n", errno);
 		return -1;
+	}
+
+	ret = acl_set_permset(entry, permset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_set_permset failed: %d\n", errno);
+		return -1;
+	}
+
+	ret = acl_set_flagset_np(entry, flagset);
+	if (ret != 0) {
+		fprintf(stderr, "sys_acl_set_info: acl_set_flagset_np failed: %d\n", errno);
+		return -1;
+	}
 
 	return 0;
 }
@@ -2742,7 +2783,8 @@
 
 int sys_acl_delete_def_file(const char *name)
 {
-	return acl_delete_def_file(name);
+	//return acl_delete_def_file(name);
+	return 0; /* Not supported on Mac OS X */
 }
 
 int sys_acl_free_acl(SMB_ACL_T the_acl)
diff -Naur -X diff_ignore rsync-3.0.6_base/lib/sysacls.h rsync/lib/sysacls.h
--- rsync-3.0.6_base/lib/sysacls.h	2008-03-01 15:01:41.000000000 -0500
+++ rsync/lib/sysacls.h	2014-12-06 21:12:18.000000000 -0500
@@ -264,6 +264,7 @@
 
 #define SMB_ACL_ENTRY_T		acl_entry_t
 
+// ACL types
 #define SMB_ACL_USER		1
 #define SMB_ACL_GROUP		2
 
@@ -288,12 +289,20 @@
 
 int sys_acl_get_entry(SMB_ACL_T the_acl, int entry_id, SMB_ACL_ENTRY_T *entry_p);
 int sys_acl_get_tag_type(SMB_ACL_ENTRY_T entry_d, SMB_ACL_TAG_T *tag_type_p);
+#ifdef HAVE_OSX_ACLS
+int sys_acl_get_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T *tag_type_p, uint32 *bits_p, unsigned char **uup);
+#else
 int sys_acl_get_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T *tag_type_p, uint32 *bits_p, id_t *u_g_id_p);
+#endif
 SMB_ACL_T sys_acl_get_file(const char *path_p, SMB_ACL_TYPE_T type);
 SMB_ACL_T sys_acl_get_fd(int fd);
 SMB_ACL_T sys_acl_init(int count);
 int sys_acl_create_entry(SMB_ACL_T *pacl, SMB_ACL_ENTRY_T *pentry);
+#ifdef HAVE_OSX_ACLS
+int sys_acl_set_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T tagtype, uint32 bits, unsigned char *uu);
+#else
 int sys_acl_set_info(SMB_ACL_ENTRY_T entry, SMB_ACL_TAG_T tagtype, uint32 bits, id_t u_g_id);
+#endif
 int sys_acl_set_access_bits(SMB_ACL_ENTRY_T entry, uint32 bits);
 int sys_acl_valid(SMB_ACL_T theacl);
 int sys_acl_set_file(const char *name, SMB_ACL_TYPE_T acltype, SMB_ACL_T theacl);
